package cpcns.dingZhi.dataSynch.service.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.baoguanqixiancelue.service.IGQuanZongWeiHuService;
import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.dataSynch.dao.IDataSynchDao;
import cpcns.dingZhi.dataSynch.service.IDataSynchService;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import cpcns.utils.tool;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("dataSynchService")
public class DataSynchServiceImpl extends DangAnBaseServiceImpl<T> implements IDataSynchService {
  @Autowired
  private IDataSynchDao dataSynchDao;
  
  @Autowired
  private IGQuanZongWeiHuService quanZongWeiHuService;
  
  public PagerVO query_SQL(User user, Integer start, Integer rows, String table, Map<String, Object> map, String orderbysql) throws Exception {
    Map<String, Object> tp = new HashMap<>();
    String[] mls = map.get("menLei").split("_");
    String ml = mls[2];
    table = String.valueOf(mls[0]) + "_" + mls[1];
    String table_ = "";
    StringBuffer sql = new StringBuffer("select dangHao,quanZongHao,baoGuanQiXian,guiDangNianDu,menLei,hangBiaoShi,");
    String filed = "cunfangweizhi";
    if (("D_WenJian".equalsIgnoreCase(table) && "XWS".equals(ml)) || "D_QUANZONGJUANXINXI".equalsIgnoreCase(table) || ("D_ZHUANTI".equalsIgnoreCase(table) && ml.endsWith("XWS"))) {
      table_ = "D_DangAnHe";
      filed = String.valueOf(filed) + ",xuhao as biaoTi,fuHeHao";
    } else if ("D_YinXiang".equalsIgnoreCase(table) || "D_ShiWu".equalsIgnoreCase(table)) {
      table_ = "D_YinXiang";
      filed = "kufangweizhi,biaoTi,0 as fuHeHao";
    } else {
      table_ = "D_AnJuan";
      filed = String.valueOf(filed) + ",biaoTi,0 as fuHeHao";
    } 
    sql.append(filed).append(" from ").append(table_).append(" t where 1=1 and zhuangTai = 1 and zhuangTai not in(:zhuangTai)");
    StringBuffer conSql = (new StringBuffer(" select count(1) from ")).append(table_).append(" t where 1=1 and zhuangTai not in(:zhuangTai)");
    StringBuffer where = new StringBuffer();
    tp.put("zhuangTai", new String[] { "3", "4" });
    String qxsql = new String("select zhuangTai from D_INIT where init_key='chaXunQuanXianKongZhi' and init_value='chaXunQuanXianKongZhi' and ZHUANGTAI=1 ");
    List<Map<String, Object>> qxlise = this.dataSynchDao.getListMap(qxsql.toString());
    if (qxlise.size() >= 1) {
      Map<String, String> tjmap = new HashMap<>();
      String quanZongHao = (String)map.get("quanZongHao");
      String checkbox = (map.get("checkbox") == null) ? "false" : (String)map.get("checkbox");
      String all_qz = this.quanZongWeiHuService.getAllQzuanZhong(user.getQuanZongHao());
      tjmap.put("guanLianQuanZong", all_qz);
      tjmap.put("checkbox", checkbox);
      tjmap.put("quanZongHao", quanZongHao);
      tjmap.put("table", table);
      sql.append(CommStatic.IsQuanXian(user, AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING"), tjmap));
    } 
    getWhere(map, tp, ml, where);
    return this.dataSynchDao.queryBySql(String.valueOf(sql.toString()) + where + orderbysql, String.valueOf(conSql.toString()) + where, tp, start.intValue(), rows.intValue());
  }
  
  private void getWhere(Map<String, Object> map, Map<String, Object> tp, String ml, StringBuffer where) {
    Object para = null;
    para = map.get("hangBiaoShis");
    if (para != null && para != "") {
      where.append(" and hangBiaoShi in(:hangBiaoShis)");
      tp.put("hangBiaoShis", para);
    } else {
      para = map.get("querystr");
      if (para != null && para != "") {
        if (StringUtils.isNotBlank(ml)) {
          where.append(" and menLei =:menLei");
          tp.put("menLei", ml);
        } 
        CommStatic.zhuHeQueryJieXi_map(where, tp, para.toString(), (String)map.get("zuHeType"), getDataType());
      } else {
        if (StringUtils.isNotBlank(ml)) {
          where.append(" and menLei =:menLei");
          tp.put("menLei", ml);
        } 
        para = map.get("quanZongHao");
        if (para != null && para != "") {
          where.append(" and quanZongHao=:quanZongHao");
          tp.put("quanZongHao", para);
        } 
        para = map.get("biaoTi");
        if (para != null && para != "") {
          where.append(" and biaoTi like :biaoTi");
          tp.put("biaoTi", "%" + para + "%");
        } 
        para = map.get("dangHao");
        if (para != null && para != "") {
          where.append(" and dangHao=:dangHao");
          tp.put("dangHao", para);
        } 
        para = map.get("baoGuanQiXian");
        if (para != null && para != "") {
          where.append(" and baoGuanQiXian=:baoGuanQiXian");
          tp.put("baoGuanQiXian", para);
        } 
        para = map.get("guiDangNianDu");
        if (para != null && para != "") {
          tp.put("guiDangNianDu", para);
          para = map.get("nd");
          if (para != null && para != "") {
            where.append(" and guiDangNianDu ").append(para).append(":guiDangNianDu");
          } else {
            where.append(" and guiDangNianDu ").append("=:guiDangNianDu");
          } 
        } 
        para = map.get("cunfangweizhi");
        if (para != null && para != "")
          if (ml.endsWith("ZP") || ml.endsWith("LY") || ml.endsWith("LX") || ml.endsWith("SW")) {
            if (StringUtils.isNotBlank((String)para)) {
              where.append(" and kufangweizhi is null ");
            } else {
              where.append(" and kufangweizhi is not null ");
            } 
          } else if (StringUtils.isNotBlank((String)para)) {
            where.append(" and cunfangweizhi is null ");
          } else {
            where.append(" and cunfangweizhi is not null ");
          }  
      } 
    } 
  }
  
  public String shuJuTongBu(HttpServletRequest request, User user) {
    String[] mls = request.getParameter("menLei").split("_");
    Map<String, Object> tp = new HashMap<>();
    Map<String, Object> map = tool.getRequestParamsMaps(request);
    StringBuffer where = new StringBuffer();
    String ml = mls[2];
    String table_ = "";
    String table = String.valueOf(mls[0]) + "_" + mls[1];
    String filed = "";
    if (("D_WenJian".equalsIgnoreCase(table) && "XWS".equals(ml)) || "D_QUANZONGJUANXINXI".equalsIgnoreCase(table) || ("D_ZHUANTI".equalsIgnoreCase(table) && ml.endsWith("XWS"))) {
      table_ = "D_DangAnHe";
      filed = String.valueOf(filed) + ",'' as szMLH,'' as szAJH";
    } else if ("D_YinXiang".equalsIgnoreCase(table) || "D_ShiWu".equalsIgnoreCase(table)) {
      table_ = "D_YinXiang";
      filed = ",muLuHao as szMLH,anJuanHao as szAJH";
    } else {
      table_ = "D_AnJuan";
      filed = String.valueOf(filed) + ",muLuHao as szMLH,anJuanHao as szAJH";
    } 
    StringBuffer sql = (new StringBuffer(" select dangHao as MainWord,quanZongHao as szQZH,0 as Type,biaoTi as szName,baoGuanQiXian as szBGQX,guiDangNianDu as szND,0 as Kind,'")).append(table_).append("'||'_'||menLei as Category,'' as Belong");
    StringBuffer hbs_sql = new StringBuffer(" select hangBiaoShi ");
    String responseMsg = "";
    sql.append(filed).append(" from ").append(table_).append(" t where 1=1 and zhuangTai = 1 and zhuangTai not in(:zhuangTai) ");
    hbs_sql.append(" from ").append(table_).append(" t where 1=1 and zhuangTai = 1 and zhuangTai not in(:zhuangTai) ");
    tp.put("zhuangTai", new String[] { "3", "4" });
    getWhere(map, tp, ml, where);
    List<Map<String, Object>> rqs = this.dataSynchDao.getListMap(String.valueOf(sql.toString()) + where, tp);
    String hjson = JsonWithJacksonUtils.getInstance().obj2Json(rqs);
    List rqhbs = this.dataSynchDao.getList(String.valueOf(hbs_sql.toString()) + where, tp);
    StringBuffer wjsql = (new StringBuffer("select w.dangHao as MainWord, w.quanZongHao as szQZH, 0 as Type, '' as szMLH, ''as szAJH,w.biaoTi as szName, w.baoGuanQiXian as szBGQX, w.guiDangNianDu as szND, 1 as Kind,'"))
      .append(table).append("'||'_'||w.menLei as Category,  t.danghao as Belong from ").append(table).append(" w,")
      .append(table_).append(" t where w.guanlianbiaoshi=t.hangbiaoshi and w.guanlianbiaoshi in (:guanlianbiaoshi)");
    Map<String, Object> wjtp = new HashMap<>();
    wjtp.put("guanlianbiaoshi", rqhbs.toArray());
    List<Map<String, Object>> wjs = this.dataSynchDao.getListMap(wjsql.toString(), wjtp);
    String wjjson = JsonWithJacksonUtils.getInstance().obj2Json(wjs);
    String jsons = String.valueOf(hjson.replaceAll("\\]", ",")) + wjjson.replaceAll("\\[", "");
    responseMsg = jsons;
    return responseMsg;
  }
  
  public boolean checkShuJu(HttpServletRequest request) {
    String[] mls = request.getParameter("menLei").split("_");
    Map<String, Object> tp = new HashMap<>();
    Map<String, Object> map = tool.getRequestParamsMaps(request);
    StringBuffer where = new StringBuffer();
    String ml = mls[2];
    String table_ = "";
    String table = String.valueOf(mls[0]) + "_" + mls[1];
    boolean mg = false;
    StringBuffer sql = new StringBuffer(" select count(hangBiaoShi) ");
    if (("D_WenJian".equalsIgnoreCase(table) && "XWS".equals(ml)) || "D_QUANZONGJUANXINXI".equalsIgnoreCase(table) || ("D_ZHUANTI".equalsIgnoreCase(table) && ml.endsWith("XWS"))) {
      table_ = "D_DangAnHe";
    } else if ("D_YinXiang".equalsIgnoreCase(table) || "D_ShiWu".equalsIgnoreCase(table)) {
      table_ = "D_YinXiang";
    } else {
      table_ = "D_AnJuan";
    } 
    sql.append(" from ").append(table_).append(" t where 1=1 and zhuangTai = 1 and zhuangTai not in(:zhuangTai) ")
      .append(" and dangHao is null ");
    tp.put("zhuangTai", new String[] { "3", "4" });
    getWhere(map, tp, ml, where);
    List<BigDecimal> count = this.dataSynchDao.getList(String.valueOf(sql.toString()) + where, tp);
    BigDecimal bd = count.get(0);
    if (bd.intValue() == 0)
      mg = true; 
    return mg;
  }
}
